=== tools/RNN/rnn_quantizer/requirements.txt ===
sklearn
scipy==1.3.1
numpy==1.17.2
tqdm
ninja
six
