=== debian/changelog ===
vitis-ai (2.0-0ubuntu1) jammy; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * New upstream release (LP: #1959382).
    - Exclude multiple invalid files from the upstream tarball that would
      make this package incompatible with universe.
  * debian/patches: drop unneeded patches, refresh still relevant ones.
  * Add debian/patches/fix-python-install.patch to allow installing the python
    modules to the debian/tmp directory for package builds.
  * Add debian/patches/fix-ftbfs-includes-and-namespaces.patch to fix
    compliation errors due to missing includes or namespaces.
  * Drop vitis-ai-dnndk as it is no longer present since 1.4+.
  * Install all the newly added Vitis-AI libraries.
  * Tweak debian/copyright to be more accurate.
  * Build python libraries and utilities for Vitis-AI-Library.

  [ Alfonso Sanchez-Beato ]
  * Move to the newer name for xrt package (xrt-embedded -> xrt)
  * Make sure all VART libraries are in vitis-ai-runtime package
  * Replace fix for -Werror=nonnull with something maybe safer

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 28 Jan 2022 12:01:04 +0100

vitis-ai (1.3.2-0ubuntu9) jammy; urgency=medium

  * Build python libraries (LP: #1958484)
  * Build with -std=gnu++17 to fix build failure

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Fri, 07 Jan 2022 03:46:51 +0000

vitis-ai (1.3.2-0ubuntu8) jammy; urgency=medium

  * d/rules: Build with -Wno-error=deprecated-declarations to fix build
    failure against OpenSSL 3.0

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 07 Dec 2021 15:54:04 +0100
