=== debian/control ===
Source: vitis-ai
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-filesystem-dev,
               libeigen3-dev,
               libgtest-dev,
               libgoogle-glog-dev,
               libjson-c-dev,
               libopencv-dev,
               libprotobuf-dev,
               libssl-dev,
               lsb-release,
               pkg-config,
               protobuf-compiler,
               xrt,
               uuid-dev,
               python3-dev,
               pybind11-dev,
Standards-Version: 4.5.0

Package: vitis-ai-runtime
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI runtime
 Vitis AI Run time enables applications to use the unified high-level
 runtime API for both cloud and edge. Therefore, making cloud-to-edge
 deployments seamless and efficient.
 The Vitis AI Runtime API features are:
 * Asynchronous submission of jobs to the accelerator
 * Asynchronous collection of jobs from the accelerator
 * C++ and Python implementations
 * Support for multi-threading and multi-process execution
 .
 This package contains the Vitis AI runtime libraries, headers, and tools.

Package: vitis-ai-library
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI library
 The Vitis AI Library is a set of high-level libraries and APIs built for
 efficient AI inference with Deep-Learning Processor Unit (DPU). It is
 built based on the Vitis AI Runtime with Unified APIs, and it fully
 supports XRT 2020.2.
 .
 The Vitis AI Library provides an easy-to-use and unified interface by
 encapsulating many efficient and high-quality neural networks. This
 simplifies the use of deep-learning neural networks, even for users
 without knowledge of deep-learning or FPGAs. The Vitis AI Library allows
 users to focus more on the development of their applications, rather
 than the underlying hardware.
