=== debian/watch ===
version=4
opts="filenamemangle=s%.*\/v(\d.*)\.tar\.gz%vitis-ai-$1.tar.gz%" \
    https://github.com/Xilinx/Vitis-AI/releases \
    .*\/v(\d.*)\.tar\.gz debian uupdate
